/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package sample.user.crud.basic.implementation;

import javax.jws.WebService;
import sample.user.crud.basic.CreateRequest;
import sample.user.crud.basic.CreateResponse;
import sample.user.crud.basic.SampleUser;
import sample.user.crud.basic.Status;
import sample.user.crud.basic.StatusCode;

/**
 *
 * @author ricky
 */
@WebService(endpointInterface="sample.user.crud.basic.CreatePort")
public class CreatePort {

    private UserMapSingleton map = UserMapSingleton.getSingleton();

    public CreateResponse create(CreateRequest request) {
        // create the resposne with the status
        CreateResponse response = new CreateResponse();
        Status status = new Status();
        response.setStatus(status);
        try {
            // check the user is well formed
            SampleUser user = request.getUser();
            if (user == null) {
                status.setStatus(StatusCode.ERROR);
                status.setMessage("User is null!");
            } else if (user.getId() == null) {
                status.setStatus(StatusCode.ERROR);
                status.setMessage("The user has no ID!");
            } else if (user.getFirstName() == null) {
                status.setStatus(StatusCode.ERROR);
                status.setMessage("The user has no FirstName!");
            } else if (user.getLastName() == null) {
                status.setStatus(StatusCode.ERROR);
                status.setMessage("The user has no LastName!");
            } else if (map.getMap().containsKey(user.getId())) {
                status.setStatus(StatusCode.ERROR);
                status.setMessage("User '" + user.getId() + "' already exists!");
            } else {
                map.getMap().put(user.getId(), user);
                status.setStatus(StatusCode.OK);
                status.setMessage("User '" + user.getId() + "' successfully created!");
            }
            return response;
        } catch (Throwable t) {
            status.setStatus(StatusCode.ERROR);
            status.setMessage(t.getMessage());
            return response;
        }
    }
}
