/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package sample.user.crud.basic.implementation;

import javax.jws.WebService;
import sample.user.crud.basic.ReadRequest;
import sample.user.crud.basic.ReadResponse;
import sample.user.crud.basic.SampleUser;
import sample.user.crud.basic.Status;
import sample.user.crud.basic.StatusCode;

/**
 *
 * @author ricky
 */
@WebService(endpointInterface = "sample.user.crud.basic.ReadPort")
public class ReadPort {

    private UserMapSingleton map = UserMapSingleton.getSingleton();

    public ReadResponse read(ReadRequest request) {
        ReadResponse response = new ReadResponse();
        Status status = new Status();
        response.setStatus(status);
        try {
            if (request.getId() == null) {
                status.setStatus(StatusCode.ERROR);
                status.setMessage("No ID passed!");
            } else {
                SampleUser user = map.getMap().get(request.getId());
                response.setUser(user);
                status.setStatus(StatusCode.OK);
                if (user == null) {
                    status.setMessage("User '" + request.getId() + "' not found!");
                }
            }
            return response;
        } catch (Throwable t) {
            status.setStatus(StatusCode.ERROR);
            status.setMessage(t.getMessage());
            return response;
        }
    }
}
