/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package sample.user.crud.basic.implementation;

import javax.jws.WebService;
import sample.user.crud.basic.SampleUser;
import sample.user.crud.basic.Status;
import sample.user.crud.basic.StatusCode;
import sample.user.crud.basic.UpdateRequest;
import sample.user.crud.basic.UpdateResponse;

/**
 *
 * @author ricky
 */
@WebService(endpointInterface = "sample.user.crud.basic.UpdatePort")
public class UpdatePort {

    private UserMapSingleton map = UserMapSingleton.getSingleton();

    public UpdateResponse update(UpdateRequest request) {
        // create the resposne with the status
        UpdateResponse response = new UpdateResponse();
        Status status = new Status();
        response.setStatus(status);
        try {
            // check the user is well formed
            SampleUser user = request.getUser();
            if (user == null) {
                status.setStatus(StatusCode.ERROR);
                status.setMessage("User is null!");
            } else if (user.getId() == null) {
                status.setStatus(StatusCode.ERROR);
                status.setMessage("The user has no ID!");
            } else if (user.getFirstName() == null) {
                status.setStatus(StatusCode.ERROR);
                status.setMessage("The user has no FirstName!");
            } else if (user.getLastName() == null) {
                status.setStatus(StatusCode.ERROR);
                status.setMessage("The user has no LastName!");
            } else if (!map.getMap().containsKey(user.getId())) {
                status.setStatus(StatusCode.ERROR);
                status.setMessage("User '" + user.getId() + "' does not exist!");
            } else {
                map.getMap().put(user.getId(), user);
                status.setStatus(StatusCode.OK);
                status.setMessage("User '" + user.getId() + "' successfully updated!");
            }
            return response;
        } catch (Throwable t) {
            status.setStatus(StatusCode.ERROR);
            status.setMessage(t.getMessage());
            return response;
        }
    }
}
