/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package sample.user.crud.basic.implementation;

import java.util.HashMap;
import java.util.Map;
import sample.user.crud.basic.SampleUser;

/**
 *
 * Singleton to store users in memory. It is initialized with two users
 * (ricky and ramon).
 *
 * @author ricky
 */
public class UserMapSingleton {

    static private UserMapSingleton singleton = null;
    private Map<String,SampleUser> map = null;

    private UserMapSingleton() {
        map = new HashMap<String,SampleUser>();
        // add ricky
        SampleUser ricky = new SampleUser();
        ricky.setId("ricky");
        ricky.setActive(true);
        ricky.setFirstName("Ricardo");
        ricky.setLastName("Martín Camarero");
        ricky.setEmail("rickyepoderi@yahoo.es");
        ricky.setEmployeeNumber("121212");
        map.put(ricky.getId(), ricky);
        // add ramon
        SampleUser ramon = new SampleUser();
        ramon.setId("ramon");
        ramon.setActive(true);
        ramon.setFirstName("Ramón");
        ramon.setLastName("Pardos Torrijo");
        ramon.setEmployeeNumber("101010");
        map.put(ramon.getId(), ramon);
    }

    static public synchronized UserMapSingleton getSingleton() {
        if (singleton == null) {
            singleton = new UserMapSingleton();
        }
        return singleton;
    }

    public Map<String,SampleUser> getMap() {
        return map;
    }

}
